
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Spark RDD API扩展开发(1) / 憋错料</title>

    <meta name="description" content="Spark RDD API扩展开发(1) 我们都知道,Apache Spark内置了很多操作数据的API.但是很多时候,当我们在现实中开发应用程序的时候,我们需要解决现实中遇到的问题,而这些问题可能在Spark中没有相应的API提供,这时候,我们就需要通过扩展Spark API来实现我们自己的方法. 我们可以通过两种方法来扩展Spark API,(1).其中一种就是在现有的RDD中添加自定义的方法:(2).第二种就是创建属于我们自己的RDD.在这篇文章中,我将对这两种方法进行阐述,并赋予代码 .下面我就开始介绍第一种方法. 假如我们中有">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Spark RDD API扩展开发(1)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>我们都知道，Apache&nbsp;<a href="http://www.iteblog.com/archives/tag/spark" rel="external nofollow noreferrer">Spark</a>内置了很多操作数据的API。但是很多时候，当我们在现实中开发应用程序的时候，我们需要解决现实中遇到的问题，而这些问题可能在<a href="http://www.iteblog.com/archives/tag/spark" rel="external nofollow noreferrer">Spark</a>中没有相应的API提供，这时候，我们就需要通过扩展Spark<br />
 API来实现我们自己的方法。</p>
<p>我们可以通过两种方法来扩展Spark API，（1）、<strong>其中一种就是在现有的RDD中添加自定义的方法</strong>；（2）、<strong>第二种就是创建属于我们自己的RDD</strong>。在这篇文章中，我将对这两种方法进行阐述，并赋予代码 。下面我就开始介绍第一种方法。</p>
<p>　　假如我们中有一些商品的销售数据，数据的&#26684;式是CSV的。为了简单起见，假如每行数据都是由id, customerId, itemId 以及itemValue四个字段组成，我们用SalesRecord来表示：</p>
<pre>class SalesRecord(valid:String,val customerId:String, val itemId:String,val itemValue:Double) extends Comparable[SalesRecord] with Serializable</pre>
<p>　　所以我们可以将商品的销售数据进行解析，并存储到RDD[SalesRecord]中：</p>
<pre>val sc =newSparkContext(args(0), &quot;iteblogRDDExtending&quot;)
val dataRDD =sc.textFile(&quot;file:///www/iteblog.csv&quot;)
val salesRecordRDD =dataRDD.map(row =&gt; {
    valcolValues =row.split(&quot;,&quot;)
    newSalesRecord(colValues(0),colValues(1),
    colValues(2),colValues(3).toDouble)
})</pre>
<p>　　如果我们想计算出这些商品的总销售额，我们会这么来写：</p>
<pre>salesRecordRDD.map(_.itemValue).sum</pre>
<p>　　虽然这看起来很简洁，但是理解起来却有点困难。但是如果我们可以这么来写，可能会很好理解：</p>
<pre>salesRecordRDD.totalSales</pre>
<p>　　在上面的代码片段中，totalSales方法让我们感觉就是Spark内置的操作一样，但是Spark是不提供这个方法的，我们需要在现有的RDD中实现我们自定义的操作。</p>
<p>　　下面我就来介绍一些如何在现有的RDD中添加我们自定义的方法。</p>
<p>　　<strong>一、定义一个工具类，来存放我们所有自定义的操作</strong></p>
<p>　　当然，你完全没必要自定义一个类类添加我们自定义的方法，但是为了管理，还是建议你这么做。下面我们来定义IteblogCustomFunctions类，它存储所有我们自定义的方法。它是专门用来处理RDD[SalesRecord]，所以这个类中提供的操作全部是用来处理销售数据的：</p>
<pre>class IteblogCustomFunctions(rdd:RDD[SalesRecord]) {
  def totalSales = rdd.map(_.itemValue).sum
}</pre>
<p>　　<strong>二、隐形转换来实现在RDD中添加方法</strong></p>
<p>　　我们定义了隐形的addIteblogCustomFunctions函数，这可以将所有操作销售数据的方法作用于RDD[SalesRecord]上：</p>
<pre>object IteblogCustomFunctions {
  implicit def addIteblogCustomFunctions(rdd:RDD[SalesRecord]) = new
  IteblogCustomFunctions(rdd)
}</pre>
<p>　　<strong>三、使用自定义的方法</strong></p>
<p>　　下面方法通过导入IteblogCustomFunctions 中的相应方法来实现使用我们自定义的方法：</p>
<pre>import IteblogCustomFunctions._
println(salesRecordRDD.totalSales)</pre>
<p>　　通过上面三步我们就可以在现有的RDD中添加我们自定义的方法。</p>
<p>转载自：http://www.iteblog.com/archives/1298</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 17:07:24 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Spark RDD API扩展开发(1)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a1e8R0.html" rel="bookmark">Spark RDD API详解&lpar;一&rpar;&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				RDD是什么? RDD是Spark中的抽象数据结构类型,任何数据在Spark中都被表示为RDD.从编程的角度来看,RDD可以简单看成是一个数组.和普通数组 的区别是,RDD中的数据是分区存储的,这样不同分区的数据就可以分布在不同的机器上,同时可以被并行处理.因此,Spark应用程序所做的无非是把需要 处理的数据转换为RDD,然后对RDD进行一系列的变换和操作从而得到结果.本文为第一部分,将介绍Spark RDD中与Map和Reduce相关的API中. 如何创建RDD? RDD可以从普通数组创建出			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38pqD23.html" rel="bookmark">Spark RDD API详解&lpar;一&rpar; Map和Reduce</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文由cmd markdown编辑,原始链接:https://www.zybuluo.com/jewes/note/35032 RDD是什么? RDD是Spark中的抽象数据结构类型,任何数据在Spark中都被表示为RDD.从编程的角度来看,RDD可以简单看成是一个数组.和普通数组 的区别是,RDD中的数据是分区存储的,这样不同分区的数据就可以分布在不同的机器上,同时可以被并行处理.因此,Spark应用程序所做的无非是把需要 处理的数据转换为RDD,然后对RDD进行一系列的变换和操作从而得到结果			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JKnkDM.html" rel="bookmark">Spark RDD API（scala）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.RDD RDD(Resilient Distributed Dataset弹性分布式数据集)是Spark中抽象的数据结构类型,任何数据在Spark中都被表示为RDD.从编程的角度来看,RDD可以简单看成是一个数组.和普通数组的区别是,RDD中的数据时分区存储的,这样不同分区的数据就可以分布在不同的机器上,同时可以被并行处理.因此,Spark应用程序所做的无非是把需要处理的数据转换为RDD,然后对RDD进行一系列的变换和操作,从而得到结果. 2.RDD创建 RDD可以从普通数组创建出来,也可以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0neeXvM.html" rel="bookmark">Apache Spark RDD（Resilient Distributed Datasets）论文</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark RDD(Resilient Distributed Datasets)论文 概要 1: 介绍 2: Resilient Distributed Datasets(RDDs) 2.1 RDD 抽象 2.2 Spark 编程接口 2.2.1 例子 – 监控日志数据挖掘 2.3 RDD 模型的优势 2.4 不适合用 RDDs 的应用 3 Spark 编程接口 3.1 Spark 中 RDD 的操作 3.2 举例应用 3.2.1 线性回归 3.2.2 PageRank 4 表达 RDDs 5			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgDj6B0.html" rel="bookmark">Apache Spark 2&period;2&period;0 中文文档 - Spark RDD（Resilient Distributed Datasets）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark RDD(Resilient Distributed Datasets)论文 概要 1: 介绍 2: Resilient Distributed Datasets(RDDs) 2.1 RDD 抽象 2.2 Spark 编程接口 2.2.1 例子 – 监控日志数据挖掘 2.3 RDD 模型的优势 2.4 不适合用 RDDs 的应用 3 Spark 编程接口 3.1 Spark 中 RDD 的操作 3.2 举例应用 3.2.1 线性回归 3.2.2 PageRank 4 表达 RDDs 5			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NKNAVM.html" rel="bookmark">Spark RDD使用详解1--RDD原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				RDD简介 在集群背后,有一个非常重要的分布式数据架构,即弹性分布式数据集(Resilient Distributed Dataset,RDD).RDD是Spark的最基本抽象,是对分布式内存的抽象使用,实现了以操作本地集合的方式来操作分布式数据集的抽象实现.RDD是Spark最核心的东西,它表示已被分区,不可变的并能够被并行操作的数据集合,不同的数据集格式对应不同的RDD实现.RDD必须是可序列化的.RDD可以cache到内存中,每次对RDD数据集的操作之后的结果,都可以存放到内存中,下一个操			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NdZD20.html" rel="bookmark">Spark记录-Spark性能优化（开发、资源、数据、shuffle）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开发调优篇 原则一:避免创建重复的RDD 通常来说,我们在开发一个Spark作业时,首先是基于某个数据源(比如Hive表或HDFS文件)创建一个初始的RDD:接着对这个RDD执行某个算子操作,然后得到下一个RDD:以此类推,循环往复,直到计算出最终我们需要的结果.在这个过程中,多个RDD会通过不同的算子操作(比如map.reduce等)串起来,这个&quot;RDD串&quot;,就是RDD lineage,也就是&quot;RDD的血缘关系链&quot;. 我们在开发过程中要注意:对于同一份数据,只应该			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e2WZp3.html" rel="bookmark">spark RDD，DataFrame&comma;DataSet 介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				弹性分布式数据集(Resilient Distributed Dataset,RDD) RDD是Spark一开始就提供的主要API,从根本上来说,一个RDD就是你的数据的一个不可变的分布式元素集合,在集群中跨节点分布,可以通过若干提供了转换和处理的底层API进行并行处理.每个RDD都被分为多个分区,这些分区运行在集群不同的节点上. RDD支持两种类型的操作,转化操作(transform)和行动操作(action).转化操作会有一个RDD生成一个新的RDD,行动操作则要计算出来一个结果.spark			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzY9624.html" rel="bookmark">Spark RDD算子实战</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[TOC] Spark算子概述 RDD:弹性分布式数据集,是一种特殊集合.支持多种来源.有容错机制.可以被缓存.支持并行操作,一个RDD代表多个分区里的数据集. RDD有两种操作算子: Transformation(转换):Transformation属于延迟计算,当一个RDD转换成另一个RDD时并没有立即进行转换,仅仅是记住了数据集的逻辑操作 Action(执行):触发Spark作业的运行,真正触发转换算子的计算 需要说明的是,下面写的scala代码,其实都是可以简写的,但是为了方便理解,我都			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/x0dgpgM.html" rel="bookmark" class="title">Ｊａｖａ面試題（实用性高）</a>
					<div>
						3.Spring MVC中的注解你都用过哪些,SpringMVC的运行原理是什么? @Controller:使其普通的java类充当控制层的作用. @RequestMapping:有两个参数 url  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r52q10.html" rel="bookmark" class="title">Atitit&period;文件搜索工具&amp;&num;160&semi;attilax&amp;&num;160&semi;总结</a>
					<div>
						Atitit.文件搜索工具 attilax 总结 1. 指定目录按照体积大小精确搜索1 1.1. File Seeker 4.5 版本的可以,3.5版本的不行..1 2. 按照文件内容搜索1 2.1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mywb8a3.html" rel="bookmark" class="title">第一个Java程序&mdash;&mdash;计算器</a>
					<div>
						第一次写的,一边写一边修改,很简单的整数计算器,拿来抛砖引玉吧 1 /* 2 *简单的计算器 3 *没有写注释,不过很简单的小程序估计也没人看吧┑(￣Д ￣)┍ 4 */ 5 6 package co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MywVnA3.html" rel="bookmark" class="title">sublime搜索和替换--多文件搜索替换</a>
					<div>
						Search and Replace - Multiple Files Searching To open the search panel for files, press Ctrl + Shift ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dgrbeM.html" rel="bookmark" class="title">Linux中的自定义变量</a>
					<div>
						范围: 只在当前Shell中生效 语法: 变量定义: name=&quot;xiaol&quot; hello=&quot;$name&quot;&quot; hello&quot; 变量调用: ec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8Llk3.html" rel="bookmark" class="title">Oracle数据库静默安装</a>
					<div>
						1.1      解压安装包 Oracle11gR2安装为两个安装包,全部解压后,需要将两个安装包的内容合并在一起后进行安装 Oracle版本 linux64_11gR2 操作系统 CentOS7.0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGEnvb3.html" rel="bookmark" class="title">使用openssl生成RSA公私密钥</a>
					<div>
						在windows 环境下 1.进入cmd命令窗口 切换到openssl程序目录下 2.输入openssl.exe,进入openssl命令模式下 3.生成私钥输入“genrsa -out app_pri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPdELDM.html" rel="bookmark" class="title">AngularJS - 插件，module注入</a>
					<div>
						Index.html &lt;body&gt; &lt;div ng-app=&quot;myApp&quot;&gt; &lt;div ng-controller=&quot;firstContro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLD7EvM.html" rel="bookmark" class="title">hdu 5170 精度控制</a>
					<div>
						众所周知,GTY是一位神犇,为了更好的虐场,他从来不写数学作业而是去屠题,他的数学老师非常不爽,但由于GTY每次考试都AK,她也不能说什么,有一天老师在黑板上写了四个数——a,b,c,da,b,c,d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myjj9n0.html" rel="bookmark" class="title">windows 7 中使用命令行创建WiFi热点</a>
					<div>
						就是让你的电脑可以作为WiFi热点,然后供其它支持WiFi的设备上网 首先你的电脑中必须有正常使用的无线网卡 幺幺幺切克闹,开始命令吧,(注:命令是在windows中的命令提示符中运行的) 禁用承载网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M61XBd4.html" rel="bookmark" class="title">A Productivity Hack in Four Quadrants</a>
					<div>
						http://www.slideshare.net/paulgordonbrown/a-productivity-hack-in-four-quadrants A Productivity Hack  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MP8YyyM.html" rel="bookmark" class="title">python的logging模块</a>
					<div>
						1.简单的将日志打印到屏幕 import logging logging.debug('This is debug message') logging.info('This is info messa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d5Vqe3.html" rel="bookmark" class="title">Python之装饰器、迭代器和生成器</a>
					<div>
						在学习python的时候,三大“名器”对没有其他语言编程经验的人来说,应该算是一个小难点,本次博客就博主自己对装饰器.迭代器和生成器理解进行解释. 为什么要使用装饰器 什么是装饰器?“装饰”从字面意思 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5Ydb3.html" rel="bookmark" class="title">VMware vCAC如何修改内置域的AD数据库</a>
					<div>
						相信大部分使用VMware vCAC的朋友都会选择用Applicance进行安装,因为直接还原OVF的方式来得是最简单的,远远要比在Windows Server上进心独立安装来得方便. 不知道有多少朋 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vQ5Na0.html" rel="bookmark" class="title">常量字符串为什么位于静态存储区？</a>
					<div>
						char *c=&quot;zhaobei&quot;;书上说: &quot;zhaobei&quot;这个字符串被当作常量而且被放置在此程序的内存静态区.那一般的int i=1;1也是常量,为什么1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4A6bwzM.html" rel="bookmark" class="title">EOSPlatform&plus;Dubbo&plus;Zookeeper最佳实践  【转】</a>
					<div>
						随着分布式服务框架的流行,许多公司都引入了业界流行的分布式服务框架,本文介绍如何使用EOSPlatform+Dubbo+Zookeeper实现分布式服务的开发与运行. 1     环境准备 1.1   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmowPP3.html" rel="bookmark" class="title">iOS苹果产品简介</a>
					<div>
						苹果产品 1.Mac mini          三四千 2.Mac book  pro 方 3.mac book Air 尖尖的比pro便宜 4.iMac(一体机)一万二以上屏幕特别大 5.Mac  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JyeDB3.html" rel="bookmark" class="title">拜师鸟哥之linux学习体会（10）&mdash;&mdash;认识与学习bash</a>
					<div>
						在linux环境下,如果你不懂得bash,那么其他的东西也就不要学了.之前讲过linux的核心是内核,我们用户必须通过某个东西来与内核进行交互,这样才能操作linux.这个东西就是shell.shel ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBY8Jv4.html" rel="bookmark" class="title">数据挖掘中基本概念--数据类型的属性与度量</a>
					<div>
						当我们在学习数据挖掘算法或者机器学习算法时,我们都会发现某些算法只能应用于特定的数据类型,所以在学习数据挖掘算法或者机器学习算法前我们需要对数据类型的属性度量有一个很清晰的了解,如果在数据类型这一步就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35wvERM.html" rel="bookmark" class="title">2016元旦台湾自由行</a>
					<div>
						/********前序/ 小时候对台湾的认识都是从课本上的来的,知道他是祖国的宝岛,知道蒋介石在国共内战后撤退到那里,知道有阿里山,有日月潭.后来台湾经济起飞,成为了亚洲四小龙,好像很富裕的样子,所以 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
